diff --git a/src/osax/common.h b/src/osax/common.h
index d00c434..35bc73d 100644
--- a/src/osax/common.h
+++ b/src/osax/common.h
@@ -1,7 +1,7 @@
 #ifndef SA_COMMON_H
 #define SA_COMMON_H
 
-#define OSAX_VERSION                "1.0.5"
+#define OSAX_VERSION                "1.0.6"
 
 #define OSAX_PAYLOAD_SUCCESS        0
 #define OSAX_PAYLOAD_NOT_FOUND      1
diff --git a/src/osax/payload.m b/src/osax/payload.m
index d19f7b3..24882ee 100644
--- a/src/osax/payload.m
+++ b/src/osax/payload.m
@@ -128,17 +128,14 @@ static uint64_t image_slide(void)
 
 static uint64_t hex_find_seq(uint64_t baddr, const char *c_pattern)
 {
-    if (!baddr)     return 0x0;
-    if (!c_pattern) return 0x0;
+    if (!baddr || !c_pattern) return 0;
 
-    int counter = 0;
     uint64_t addr = baddr;
     uint64_t pattern_length = (strlen(c_pattern) + 1) / 3;
-
     char buffer_a[pattern_length];
     char buffer_b[pattern_length];
-    memset(buffer_a, '\0', sizeof(buffer_a));
-    memset(buffer_b, '\0', sizeof(buffer_b));
+    memset(buffer_a, 0, sizeof(buffer_a));
+    memset(buffer_b, 0, sizeof(buffer_b));
 
     char *pattern = (char *) c_pattern + 1;
     for (int i = 0; i < pattern_length; ++i) {
@@ -146,51 +143,28 @@ static uint64_t hex_find_seq(uint64_t baddr, const char *c_pattern)
         if (c == '?') {
             buffer_b[i] = 1;
         } else {
-            int temp = 9;
-            if (c <= '9') {
-                temp = 0;
-            }
+            int temp = c <= '9' ? 0 : 9;
             temp = (temp + c) << 0x4;
             c = pattern[0];
-            int temp2 = 0xc9;
-            if (c <= '9') {
-                temp2 = 0xd0;
-            }
+            int temp2 = c <= '9' ? 0xd0 : 0xc9;
             buffer_a[i] = temp2 + c + temp;
         }
         pattern += 3;
     }
-    goto loc_59f2;
-
-loc_59f2:
-    if (pattern_length < 3) goto loc_5a14;
 
-loc_59f8:
-    counter = 0;
-    goto loc_59fa;
-
-loc_59fa:
-    if (buffer_b[counter] != 0 || ((char *)addr)[counter] == buffer_a[counter]) goto loc_5a0c;
-
-loc_5a19:
-    addr = (uint64_t)((char *)addr + 1);
-    if (addr - baddr < 0x286a0) goto loc_59f2;
-
-loc_5a2a:
-    addr = 0;
-    goto loc_5a2d;
+loop:
+    for (int counter = 0; counter < pattern_length; ++counter) {
+        if ((buffer_b[counter] == 0) && (((char *)addr)[counter] != buffer_a[counter])) {
+            addr = (uint64_t)((char *)addr + 1);
+            if (addr - baddr < 0x286a0) {
+                goto loop;
+            } else {
+                return 0;
+            }
+        }
+    }
 
-loc_5a2d:
     return addr;
-
-loc_5a0c:
-    counter = counter + 1;
-    if (counter < pattern_length) goto loc_59fa;
-
-loc_5a14:
-    if (addr != 0x0) goto loc_5a2d;
-
-    return 0;
 }
 
 uint64_t get_dock_spaces_offset(NSOperatingSystemVersion os_version) {
@@ -232,7 +206,7 @@ uint64_t get_add_space_offset(NSOperatingSystemVersion os_version) {
 
 uint64_t get_remove_space_offset(NSOperatingSystemVersion os_version) {
     if (os_version.minorVersion == 15) {
-        return 0x330000;
+        return 0x320000;
     } else if (os_version.minorVersion == 14) {
         return 0x37fb00;
     } else if (os_version.minorVersion == 13) {
diff --git a/src/osax/sa_payload.c b/src/osax/sa_payload.c
index eff8b32..0b927cc 100644
--- a/src/osax/sa_payload.c
+++ b/src/osax/sa_payload.c
@@ -183,8 +183,8 @@ unsigned char __src_osax_payload[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x18, 0x8f, 0x00, 0x00, 0x73, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x1b, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x7e, 0xc9, 0x9a, 0x1f,
-  0xf0, 0xb1, 0x30, 0xb7, 0x82, 0xd7, 0xb4, 0xfc, 0x21, 0xce, 0x05, 0x5d,
+  0x1b, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x5b, 0x8c, 0xc4, 0xf4,
+  0x24, 0x58, 0x35, 0xff, 0xb5, 0x51, 0x68, 0x73, 0xba, 0x79, 0x3b, 0xed,
   0x32, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
   0x00, 0x0e, 0x0a, 0x00, 0x00, 0x0e, 0x0a, 0x00, 0x01, 0x00, 0x00, 0x00,
   0x03, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc2, 0x01, 0x2a, 0x00, 0x00, 0x00,
@@ -667,7 +667,7 @@ unsigned char __src_osax_payload[] = {
   0x89, 0x1d, 0x5e, 0x57, 0x00, 0x00, 0x48, 0x8b, 0x85, 0x68, 0xff, 0xff,
   0xff, 0x48, 0x83, 0xf8, 0x0d, 0x74, 0x1d, 0x48, 0x83, 0xf8, 0x0e, 0x74,
   0x28, 0x48, 0x83, 0xf8, 0x0f, 0x75, 0x46, 0x49, 0x8d, 0xbc, 0x24, 0x00,
-  0x00, 0x33, 0x00, 0x48, 0x8d, 0x35, 0xc3, 0x3b, 0x00, 0x00, 0xeb, 0x3a,
+  0x00, 0x32, 0x00, 0x48, 0x8d, 0x35, 0xc3, 0x3b, 0x00, 0x00, 0xeb, 0x3a,
   0x49, 0x8d, 0xbc, 0x24, 0x00, 0x50, 0x49, 0x00, 0x48, 0x8d, 0x35, 0x20,
   0x40, 0x00, 0x00, 0xeb, 0x29, 0x49, 0x8d, 0xbc, 0x24, 0x00, 0xfb, 0x37,
   0x00, 0x48, 0x83, 0xbd, 0x70, 0xff, 0xff, 0xff, 0x03, 0x48, 0x8d, 0x05,
@@ -717,23 +717,23 @@ unsigned char __src_osax_payload[] = {
   0x98, 0x4e, 0x00, 0x00, 0x48, 0x8b, 0x00, 0x48, 0x89, 0x45, 0xd0, 0x31,
   0xc0, 0x48, 0x85, 0xff, 0x0f, 0x84, 0x21, 0x01, 0x00, 0x00, 0x49, 0x89,
   0xf7, 0x48, 0x85, 0xf6, 0x0f, 0x84, 0x15, 0x01, 0x00, 0x00, 0x48, 0x89,
-  0xf9, 0x4c, 0x89, 0xff, 0x48, 0x89, 0x4d, 0xc8, 0xe8, 0x83, 0x29, 0x00,
-  0x00, 0x48, 0x89, 0xc3, 0x48, 0xff, 0xc3, 0x48, 0xb9, 0xab, 0xaa, 0xaa,
-  0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x48, 0x89, 0xd8, 0x48, 0xf7, 0xe1, 0x49,
-  0x89, 0xd5, 0x48, 0x89, 0x65, 0xc0, 0x49, 0xd1, 0xed, 0x49, 0x8d, 0x45,
-  0x0f, 0x48, 0x83, 0xe0, 0xf0, 0x49, 0x89, 0xe4, 0x49, 0x29, 0xc4, 0x4c,
-  0x89, 0xe4, 0x49, 0x89, 0xe6, 0x49, 0x29, 0xc6, 0x4c, 0x89, 0xf4, 0x4c,
-  0x89, 0xe7, 0x4c, 0x89, 0xee, 0xe8, 0x96, 0x28, 0x00, 0x00, 0x4c, 0x89,
-  0xf7, 0x4c, 0x89, 0xee, 0xe8, 0x8b, 0x28, 0x00, 0x00, 0x48, 0x8b, 0x75,
-  0xc8, 0x48, 0x89, 0xdf, 0x48, 0x89, 0xf0, 0x48, 0x83, 0xfb, 0x03, 0x72,
-  0x58, 0x49, 0xff, 0xc7, 0x31, 0xc0, 0x66, 0x0f, 0x1f, 0x44, 0x00, 0x00,
+  0x7d, 0xc8, 0x4c, 0x89, 0xff, 0xe8, 0x86, 0x29, 0x00, 0x00, 0x48, 0x89,
+  0xc3, 0x48, 0xff, 0xc3, 0x48, 0xb9, 0xab, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa,
+  0xaa, 0xaa, 0x48, 0x89, 0xd8, 0x48, 0xf7, 0xe1, 0x49, 0x89, 0xd5, 0x48,
+  0x89, 0x65, 0xc0, 0x49, 0xd1, 0xed, 0x49, 0x8d, 0x45, 0x0f, 0x48, 0x83,
+  0xe0, 0xf0, 0x49, 0x89, 0xe4, 0x49, 0x29, 0xc4, 0x4c, 0x89, 0xe4, 0x49,
+  0x89, 0xe6, 0x49, 0x29, 0xc6, 0x4c, 0x89, 0xf4, 0x4c, 0x89, 0xe7, 0x4c,
+  0x89, 0xee, 0xe8, 0x99, 0x28, 0x00, 0x00, 0x4c, 0x89, 0xf7, 0x4c, 0x89,
+  0xee, 0xe8, 0x8e, 0x28, 0x00, 0x00, 0x48, 0x89, 0xdf, 0x48, 0x8b, 0x75,
+  0xc8, 0x48, 0x83, 0xfb, 0x03, 0x72, 0x5b, 0x49, 0xff, 0xc7, 0x31, 0xc0,
+  0x66, 0x2e, 0x0f, 0x1f, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66, 0x90,
   0x41, 0x0f, 0xb6, 0x5f, 0xff, 0xb1, 0x01, 0x4c, 0x89, 0xf2, 0x80, 0xfb,
   0x3f, 0x74, 0x2c, 0x80, 0xfb, 0x3a, 0x7c, 0x0c, 0xb2, 0x09, 0xeb, 0x0a,
   0x0f, 0x1f, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x31, 0xd2, 0x00, 0xda,
   0xc0, 0xe2, 0x04, 0x41, 0x0f, 0xb6, 0x0f, 0xb3, 0xd0, 0x80, 0xf9, 0x3a,
   0x7c, 0x02, 0xb3, 0xc9, 0x00, 0xd1, 0x00, 0xd9, 0x4c, 0x89, 0xe2, 0x88,
   0x0c, 0x02, 0x49, 0x83, 0xc7, 0x03, 0x48, 0xff, 0xc0, 0x49, 0x39, 0xc5,
-  0x77, 0xb6, 0x48, 0x89, 0xf0, 0x48, 0x83, 0xff, 0x09, 0x72, 0x41, 0x31,
+  0x77, 0xb6, 0x48, 0x89, 0xf0, 0x48, 0x83, 0xff, 0x03, 0x72, 0x41, 0x31,
   0xc9, 0x66, 0x2e, 0x0f, 0x1f, 0x84, 0x00, 0x00, 0x00, 0x00, 0x00, 0x90,
   0x41, 0x80, 0x3c, 0x0e, 0x00, 0x75, 0x0a, 0x0f, 0xb6, 0x14, 0x08, 0x41,
   0x3a, 0x14, 0x0c, 0x75, 0x0a, 0x48, 0xff, 0xc1, 0x49, 0x39, 0xcd, 0x77,
@@ -798,7 +798,7 @@ unsigned char __src_osax_payload[] = {
   0x51, 0x00, 0x00, 0x00, 0x0f, 0x44, 0xd9, 0xbe, 0xf5, 0x03, 0x00, 0x00,
   0x48, 0x8d, 0xbd, 0xcb, 0xf9, 0xff, 0xff, 0xe8, 0x28, 0x25, 0x00, 0x00,
   0xc7, 0x85, 0xc0, 0xf9, 0xff, 0xff, 0x31, 0x2e, 0x30, 0x2e, 0x66, 0xc7,
-  0x85, 0xc4, 0xf9, 0xff, 0xff, 0x35, 0x00, 0x89, 0x9d, 0xc6, 0xf9, 0xff,
+  0x85, 0xc4, 0xf9, 0xff, 0xff, 0x36, 0x00, 0x89, 0x9d, 0xc6, 0xf9, 0xff,
   0xff, 0xc6, 0x85, 0xca, 0xf9, 0xff, 0xff, 0x0a, 0xba, 0x0b, 0x00, 0x00,
   0x00, 0x31, 0xc9, 0x8b, 0xbd, 0x5c, 0xff, 0xff, 0xff, 0x48, 0x8d, 0xb5,
   0xc0, 0xf9, 0xff, 0xff, 0xe8, 0x79, 0x25, 0x00, 0x00, 0xe9, 0xda, 0xfd,
@@ -2339,7 +2339,7 @@ unsigned char __src_osax_payload[] = {
   0x6e, 0x64, 0x6f, 0x77, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x6f, 0x77, 0x00,
   0x77, 0x69, 0x6e, 0x64, 0x6f, 0x77, 0x5f, 0x73, 0x68, 0x61, 0x64, 0x6f,
   0x77, 0x5f, 0x69, 0x72, 0x72, 0x65, 0x76, 0x65, 0x72, 0x73, 0x69, 0x62,
-  0x6c, 0x65, 0x00, 0x31, 0x2e, 0x30, 0x2e, 0x35, 0x00, 0x5f, 0x63, 0x75,
+  0x6c, 0x65, 0x00, 0x31, 0x2e, 0x30, 0x2e, 0x36, 0x00, 0x5f, 0x63, 0x75,
   0x72, 0x72, 0x65, 0x6e, 0x74, 0x53, 0x70, 0x61, 0x63, 0x65, 0x00, 0x25,
   0x6c, 0x6c, 0x64, 0x00, 0x5f, 0x64, 0x69, 0x73, 0x70, 0x6c, 0x61, 0x79,
   0x53, 0x70, 0x61, 0x63, 0x65, 0x73, 0x00, 0x76, 0x38, 0x40, 0x3f, 0x30,
@@ -2375,7 +2375,7 @@ unsigned char __src_osax_payload[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x49, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0xfb, 0x37, 0x00, 0x00, 0x00, 0x00, 0x00,
-  0x00, 0x00, 0x33, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
+  0x00, 0x00, 0x32, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00,
   0x1c, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x01, 0x61, 0x01, 0x03, 0x01, 0xd1, 0x58, 0x05, 0x01,
